{{
StringTest2.spin
}}
con
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

obj
  sx  : "FullDuplexSingleton"

pub main | t0, t1
  sx.start(31,30,0,115200)
  waitcnt(clkfreq*1+cnt)
  sx.str(string(sx#EOL,"Parsing speed test."))
  t0 := cnt
  stringTest
  t1 := cnt
  sx.str(string(sx#EOL,"Time to find last element on 250 lines: "))
  sx.out(" ")
  sx.dec((t1-t0)/(clkfreq/1))
  sx.out(".")
  sx.dec((t1-t0)/(clkfreq/1000)-1000)
  sx.out("s")

  repeat
' end of main

dat
data
file    "data.txt"  ' contains 250 records
dataend

pub stringTest | p, lp, sp, end, n

  sp := @data
  repeat while sp < @dataend
    end := indexOf(sp,$d)
    if end < 0
        quit
    lp := substring(sp,0,end)
    n  := rindexOf(lp," ")
    'sx.str(substring(lp,n,strsize(lp)-n))
    'sx.out(sx#EOL)
    sp += end

    if byte[sp] == $d
        sp++

pub indexOf(str,c) | n,len
'' indexOf finds char c in str from begining and returns position as an integer
'' returns -1 if not found
  len := strsize(str)
  repeat n from 0 to len
    if byte[str+n] == c
      return n
  result~~

pub rindexOf(str,c) | n, len
'' indexOf finds char c in str from right to left and returns position as an integer
'' returns -1 if not found
  n := strsize(str)
  repeat while n-- > 0
    if byte[str+n] == c
      return n
  result := -1


pub subString(str,beg,len) | n,slen,save
'' substring returns a chunk of str from position beg to beg+len limited to 256 chars
'' return 0 if something bad happened. doesn't attempt to preserve original str
  ifnot str
    return 0

  if len > 0 and len < SUBSTLEN
    bytemove(@subst,str+beg,len)
    subst[len] := 0
    return @subst
  else
    return 0

con
  SUBSTLEN = 1024
var
  byte subst[SUBSTLEN]   ' make this dynamic when memory garbage collector is working

